'
' SID dump player.
' Plays real C64 music dumped from .sid files.
'

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    
    SD_PINS  = 0
    playRate = 50'Hz
                        
VAR
  byte  buffer[25]

OBJ
  SID : "SIDCog"
  SD  : "fsrw" 
  
PUB Main 

  sd.mount(SD_PINS)                     ' Mount SD card
  SID.start                             ' Start the emulated SID in one cog
  sd.popen(string("Russian.dmp"),"r")   ' Open the tune
    
  repeat
    waitcnt(cnt+(clkfreq/playRate))     ' Wait one VBL
    if( sd.pread(@buffer,25)) < 0       ' Read 25 bytes from SD card
    SID.updateRegisters(@buffer)        ' Write 25 byte to SIDcogs 25 registers
 